using System;
using System.Data;
using System.Data.SqlClient;
using Municipalidad.Utils;
using Seguridad.DataModel;
using Seguridad.DataSetFT;

namespace Seguridad.DataAccess
{
	/// <summary>
	/// Descripción breve de Sucursal.
	/// </summary>
	public class Sucursal
	{
		public Sucursal()
		{
			//
			// TODO: agregar aquí la lógica del constructor
			//
		}
		//Field para almacenar la conexión
		private SqlConnection _connection = null;

		/// <summary>
		/// Constructor
		/// </summary>
		/// <param name="connection"></param>
		public Sucursal(SqlConnection connection)
		{
			_connection = connection;
		}

		/// <summary>
		/// 
		/// </summary>
		/// <returns></returns>
		public DSSucursal SelectAll(string idEmpresa, int idSistema)
		{
			//Almacena retorno del SqlCommand
			DataSet ds;

			try
			{
				//Ejecuta el SqlCommand
				ds = UtilsDB.ExecuteDataset(_connection, CommandType.StoredProcedure, Schema.Sucursal.SP_SELECT_ALL, 
					UtilsDB.MP("@idCodEmpresa", SqlDbType.Char, 4, idEmpresa),
					UtilsDB.MP("@idSistema", SqlDbType.Int, 4, idSistema));
			}
			catch (Exception ex)
			{
				throw ex;
			}

			return GetDSFT(ds);
		}

		internal DSSucursal GetDSFT(DataSet ds)
		{
			DSSucursal DSFT = new DSSucursal();
			DataRow rowDS;
			foreach(DataRow dr in ds.Tables[0].Rows)
			{
				rowDS = DSFT.Tables[0].NewRow();
				foreach(DataColumn dc in DSFT.Tables[0].Columns)
					rowDS[dc.ColumnName] =  dr[dc.ColumnName];
				
				DSFT.Tables[0].Rows.Add(rowDS);
			}
			return DSFT;
		}

	}
}
